Bug 1010392 - prelink causes python and others to crash on s390x
prelink causes python and others to crash on s390x
Status: CLOSED EOL
Product: Fedora
Classification: Fedora
Component: prelink (Show other bugs)
19
s390x Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Jakub Jelinek
Fedora Extras Quality Assurance
:
Depends On: 1013801
Blocks:
  Show dependency treegraph
 
Reported: 2013-09-20 12:57 EDT by Richard Sandiford
Modified: 2015-02-18 06:14 EST (History)
2 users (show)

See Also:
Fixed In Version: prelink-0.5.0-3.el7
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-02-18 06:14:01 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Suggested fix (518 bytes, patch)
2013-09-20 12:57 EDT, Richard Sandiford
no flags Details | Diff

  None (edit)
Description Richard Sandiford 2013-09-20 12:57:44 EDT
Created attachment 800574 [details]
Suggested fix

Description of problem:

  The prelinker causes several programs to crash on s390x.  The problem
  is that an R_390_IRELATIVE relocation for a memcpy IPLT in libc gets
  added to the conflict list as a normal R_390_64 relocation.  The IPLT
  then ends up calling the ifunc resolver rather than a real memcpy
  implementation.

Version-Release number of selected component (if applicable):

  prelink-0.5.0-1.fc19.s390x

Steps to Reproduce:

  From an un-prelinked state:

    $ sudo prelink /usr/bin/python
    $ python
    Segmentation fault (core dumped)
    $ sudo prelink -u /usr/bin/python
    $ python
    Python 2.7.5 (default, Aug 27 2013, 05:19:42)
    [GCC 4.8.1 20130603 (Red Hat 4.8.1-1)] on linux2
    Type "help", "copyright", "credits" or "license" for more information.
    >>>

The attached patch fixes things for me.
Comment 1 Jakub Jelinek 2013-09-30 16:07:32 EDT
Looks correct, committed as r207 to prelink SVN.  Will try to add a testcase tomorrow.
Comment 2 Jakub Jelinek 2013-10-01 05:19:51 EDT
I've also committed s390 and s390x additions to testsuite/ifunc.h, with r207 reverted all the ifunc* tests FAIL on s390x, with r207 they all pass.
Comment 3 Jakub Jelinek 2013-10-05 11:20:39 EDT
There was a similar bug to this in s390 31-bit support, committed as r209.
Comment 4 Fedora End Of Life 2015-01-09 17:35:50 EST
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.
Comment 5 Fedora End Of Life 2015-02-18 06:14:01 EST
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.